# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::OperationalInsights::Mgmt::V2020_03_01_preview
  module Models
    #
    # The top level data export resource container.
    #
    class DataExport < ProxyResource

      include MsRestAzure

      # @return [String] The data export rule ID.
      attr_accessor :data_export_id

      # @return [Array<String>] An array of tables to export, for example:
      # [“Heartbeat, SecurityEvent”].
      attr_accessor :table_names

      # @return [String] The destination resource ID. This can be copied from
      # the Properties entry of the destination resource in Azure.
      attr_accessor :resource_id

      # @return [Type] The type of the destination resource. Possible values
      # include: 'StorageAccount', 'EventHub'
      attr_accessor :data_export_type

      # @return [String] Optional. Allows to define an Event Hub name. Not
      # applicable when destination is Storage Account.
      attr_accessor :event_hub_name

      # @return [Boolean] Active when enabled.
      attr_accessor :enable

      # @return [String] The latest data export rule modification time.
      attr_accessor :created_date

      # @return [String] Date and time when the export was last modified.
      attr_accessor :last_modified_date


      #
      # Mapper for DataExport class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'DataExport',
          type: {
            name: 'Composite',
            class_name: 'DataExport',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              data_export_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.dataExportId',
                type: {
                  name: 'String'
                }
              },
              table_names: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.tableNames',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              resource_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.destination.resourceId',
                type: {
                  name: 'String'
                }
              },
              data_export_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.destination.type',
                type: {
                  name: 'String'
                }
              },
              event_hub_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.destination.metaData.eventHubName',
                type: {
                  name: 'String'
                }
              },
              enable: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.enable',
                type: {
                  name: 'Boolean'
                }
              },
              created_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.createdDate',
                type: {
                  name: 'String'
                }
              },
              last_modified_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.lastModifiedDate',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
